Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1377)
@@ -122,8 +122,5 @@
 , m_elRapSliceBEnabled(0)
 {
-  for(UInt layer=0; layer<MAX_LAYERS; layer++)
-  {
-    m_acLayerCfg[layer].setAppEncCfg(this);
-  }
+  memset( m_apcLayerCfg, NULL, sizeof(m_apcLayerCfg) );
   memset( m_scalabilityMask, 0, sizeof(m_scalabilityMask) );
 }
@@ -186,20 +183,25 @@
 {
 #if SVC_EXTENSION
-  for(Int layer = 0; layer < MAX_LAYERS; layer++)
-  {
-    if( m_acLayerCfg[layer].m_numSamplePredRefLayers > 0 )
-    {
-      delete [] m_acLayerCfg[layer].m_samplePredRefLayerIds;
-      m_acLayerCfg[layer].m_samplePredRefLayerIds = NULL;
-    }
-    if( m_acLayerCfg[layer].m_numMotionPredRefLayers > 0 )
-    {
-      delete [] m_acLayerCfg[layer].m_motionPredRefLayerIds;
-      m_acLayerCfg[layer].m_motionPredRefLayerIds = NULL;
-    }
-    if( m_acLayerCfg[layer].m_numActiveRefLayers > 0 )
-    {
-      delete [] m_acLayerCfg[layer].m_predLayerIds;
-      m_acLayerCfg[layer].m_predLayerIds = NULL;
+  for( Int layer = 0; layer < m_numLayers; layer++ )
+  {
+    if( m_apcLayerCfg[layer]->m_numSamplePredRefLayers > 0 )
+    {
+      delete [] m_apcLayerCfg[layer]->m_samplePredRefLayerIds;
+      m_apcLayerCfg[layer]->m_samplePredRefLayerIds = NULL;
+    }
+    if( m_apcLayerCfg[layer]->m_numMotionPredRefLayers > 0 )
+    {
+      delete [] m_apcLayerCfg[layer]->m_motionPredRefLayerIds;
+      m_apcLayerCfg[layer]->m_motionPredRefLayerIds = NULL;
+    }
+    if( m_apcLayerCfg[layer]->m_numActiveRefLayers > 0 )
+    {
+      delete [] m_apcLayerCfg[layer]->m_predLayerIds;
+      m_apcLayerCfg[layer]->m_predLayerIds = NULL;
+    }
+    if( m_apcLayerCfg[layer] )
+    {
+      delete m_apcLayerCfg[layer];
+      m_apcLayerCfg[layer] = NULL;
     }
   }
@@ -752,4 +754,38 @@
 // ====================================================================================================================
 
+#if SVC_EXTENSION
+/** \param  argc        number of arguments
+    \param  argv        array of arguments
+    \retval             true when success
+ */
+Bool TAppEncCfg::parseCfgNumLayersAndInit( Int argc, Char* argv[] )
+{
+  po::Options opts;
+  opts.addOptions()
+  ("c",    po::parseConfigFile, "configuration file name")
+  ("NumLayers",                                     m_numLayers,                                             1, "Number of layers to code")
+  ;
+
+  po::setDefaults(opts);
+  po::ErrorReporter err;
+  err.verbose = false;
+  po::scanArgv(opts, argc, (const Char**) argv, err);
+
+  if( m_numLayers <= 0 )
+  {
+    printf("Wrong number of layers %d\n", m_numLayers);
+    return false;
+  }
+
+  for( Int layer = 0; layer < m_numLayers; layer++ )
+  {
+    m_apcLayerCfg[layer] = new TAppEncLayerCfg;
+    m_apcLayerCfg[layer]->setAppEncCfg(this);
+  }
+
+  return true;
+}
+#endif
+
 /** \param  argc        number of arguments
     \param  argv        array of arguments
@@ -866,51 +902,51 @@
   Int*    cfg_layerPTLIdx[MAX_VPS_LAYER_IDX_PLUS1];
 
-  for( UInt layer = 0; layer < MAX_LAYERS; layer++ )
-  {
-    cfg_InputFile[layer]    = &m_acLayerCfg[layer].m_cInputFile;
-    cfg_ReconFile[layer]    = &m_acLayerCfg[layer].m_cReconFile;
-    cfg_fQP[layer]          = &m_acLayerCfg[layer].m_fQP;
+  for( UInt layer = 0; layer < m_numLayers; layer++ )
+  {
+    cfg_InputFile[layer]    = &m_apcLayerCfg[layer]->m_cInputFile;
+    cfg_ReconFile[layer]    = &m_apcLayerCfg[layer]->m_cReconFile;
+    cfg_fQP[layer]          = &m_apcLayerCfg[layer]->m_fQP;
 #if Q0074_COLOUR_REMAPPING_SEI
-    cfg_colourRemapSEIFileRoot[layer] = &m_acLayerCfg[layer].m_colourRemapSEIFileRoot;
-#endif
-    cfg_repFormatIdx[layer]         = &m_acLayerCfg[layer].m_repFormatIdx;
-    cfg_layerId[layer]              = &m_acLayerCfg[layer].m_layerId;
-    cfg_SourceWidth[layer]          = &m_acLayerCfg[layer].m_iSourceWidth;
-    cfg_SourceHeight[layer]         = &m_acLayerCfg[layer].m_iSourceHeight;
-    cfg_FrameRate[layer]            = &m_acLayerCfg[layer].m_iFrameRate; 
-    cfg_IntraPeriod[layer]          = &m_acLayerCfg[layer].m_iIntraPeriod; 
-    cfg_conformanceMode[layer]      = &m_acLayerCfg[layer].m_conformanceMode;
-    cfg_confWinLeft[layer]          = &m_acLayerCfg[layer].m_confWinLeft;
-    cfg_confWinRight[layer]         = &m_acLayerCfg[layer].m_confWinRight;
-    cfg_confWinTop[layer]           = &m_acLayerCfg[layer].m_confWinTop;
-    cfg_confWinBottom[layer]        = &m_acLayerCfg[layer].m_confWinBottom;
-    cfg_aiPadX[layer]               = &m_acLayerCfg[layer].m_aiPad[0];
-    cfg_aiPadY[layer]               = &m_acLayerCfg[layer].m_aiPad[1];
-    cfg_useExtendedPrecision[layer] = &m_acLayerCfg[layer].m_extendedPrecisionProcessingFlag;
-
-    cfg_maxCuDQPDepth[layer]        = &m_acLayerCfg[layer].m_iMaxCuDQPDepth;
+    cfg_colourRemapSEIFileRoot[layer] = &m_apcLayerCfg[layer]->m_colourRemapSEIFileRoot;
+#endif
+    cfg_repFormatIdx[layer]         = &m_apcLayerCfg[layer]->m_repFormatIdx;
+    cfg_layerId[layer]              = &m_apcLayerCfg[layer]->m_layerId;
+    cfg_SourceWidth[layer]          = &m_apcLayerCfg[layer]->m_iSourceWidth;
+    cfg_SourceHeight[layer]         = &m_apcLayerCfg[layer]->m_iSourceHeight;
+    cfg_FrameRate[layer]            = &m_apcLayerCfg[layer]->m_iFrameRate; 
+    cfg_IntraPeriod[layer]          = &m_apcLayerCfg[layer]->m_iIntraPeriod; 
+    cfg_conformanceMode[layer]      = &m_apcLayerCfg[layer]->m_conformanceMode;
+    cfg_confWinLeft[layer]          = &m_apcLayerCfg[layer]->m_confWinLeft;
+    cfg_confWinRight[layer]         = &m_apcLayerCfg[layer]->m_confWinRight;
+    cfg_confWinTop[layer]           = &m_apcLayerCfg[layer]->m_confWinTop;
+    cfg_confWinBottom[layer]        = &m_apcLayerCfg[layer]->m_confWinBottom;
+    cfg_aiPadX[layer]               = &m_apcLayerCfg[layer]->m_aiPad[0];
+    cfg_aiPadY[layer]               = &m_apcLayerCfg[layer]->m_aiPad[1];
+    cfg_useExtendedPrecision[layer] = &m_apcLayerCfg[layer]->m_extendedPrecisionProcessingFlag;
+
+    cfg_maxCuDQPDepth[layer]        = &m_apcLayerCfg[layer]->m_iMaxCuDQPDepth;
 
     // coding unit (CU) definition
-    cfg_uiMaxCUWidth[layer]  = &m_acLayerCfg[layer].m_uiMaxCUWidth;
-    cfg_uiMaxCUHeight[layer] = &m_acLayerCfg[layer].m_uiMaxCUHeight;
-    cfg_uiMaxCUDepth[layer]  = &m_acLayerCfg[layer].m_uiMaxCUDepth;
+    cfg_uiMaxCUWidth[layer]  = &m_apcLayerCfg[layer]->m_uiMaxCUWidth;
+    cfg_uiMaxCUHeight[layer] = &m_apcLayerCfg[layer]->m_uiMaxCUHeight;
+    cfg_uiMaxCUDepth[layer]  = &m_apcLayerCfg[layer]->m_uiMaxCUDepth;
 
     // transfom unit (TU) definition.
-    cfg_uiQuadtreeTULog2MaxSize[layer] = &m_acLayerCfg[layer].m_uiQuadtreeTULog2MaxSize;
-    cfg_uiQuadtreeTULog2MinSize[layer] = &m_acLayerCfg[layer].m_uiQuadtreeTULog2MinSize;
-
-    cfg_uiQuadtreeTUMaxDepthInter[layer] = &m_acLayerCfg[layer].m_uiQuadtreeTUMaxDepthInter;
-    cfg_uiQuadtreeTUMaxDepthIntra[layer] = &m_acLayerCfg[layer].m_uiQuadtreeTUMaxDepthIntra;
-
-    cfg_numSamplePredRefLayers  [layer] = &m_acLayerCfg[layer].m_numSamplePredRefLayers;
+    cfg_uiQuadtreeTULog2MaxSize[layer] = &m_apcLayerCfg[layer]->m_uiQuadtreeTULog2MaxSize;
+    cfg_uiQuadtreeTULog2MinSize[layer] = &m_apcLayerCfg[layer]->m_uiQuadtreeTULog2MinSize;
+
+    cfg_uiQuadtreeTUMaxDepthInter[layer] = &m_apcLayerCfg[layer]->m_uiQuadtreeTUMaxDepthInter;
+    cfg_uiQuadtreeTUMaxDepthIntra[layer] = &m_apcLayerCfg[layer]->m_uiQuadtreeTUMaxDepthIntra;
+
+    cfg_numSamplePredRefLayers  [layer] = &m_apcLayerCfg[layer]->m_numSamplePredRefLayers;
     cfg_samplePredRefLayerIdsPtr[layer] = &cfg_samplePredRefLayerIds[layer];
-    cfg_numMotionPredRefLayers  [layer] = &m_acLayerCfg[layer].m_numMotionPredRefLayers;
+    cfg_numMotionPredRefLayers  [layer] = &m_apcLayerCfg[layer]->m_numMotionPredRefLayers;
     cfg_motionPredRefLayerIdsPtr[layer] = &cfg_motionPredRefLayerIds[layer];
-    cfg_numActiveRefLayers  [layer] = &m_acLayerCfg[layer].m_numActiveRefLayers;
+    cfg_numActiveRefLayers  [layer] = &m_apcLayerCfg[layer]->m_numActiveRefLayers;
     cfg_predLayerIdsPtr     [layer] = &cfg_predLayerIds[layer];
 
-    cfg_numRefLayerLocationOffsets [layer] = &m_acLayerCfg[layer].m_numRefLayerLocationOffsets;
-    cfg_waveFrontSynchro[layer]  = &m_acLayerCfg[layer].m_waveFrontSynchro;
-    for(Int i = 0; i < MAX_LAYERS; i++)
+    cfg_numRefLayerLocationOffsets [layer] = &m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets;
+    cfg_waveFrontSynchro[layer]  = &m_apcLayerCfg[layer]->m_waveFrontSynchro;
+    for(Int i = 0; i < m_numLayers; i++)
     {
       cfg_refLocationOffsetLayerIdPtr  [layer] = &cfg_refLocationOffsetLayerId[layer];
@@ -932,27 +968,27 @@
     }
 #if RC_SHVC_HARMONIZATION
-    cfg_RCEnableRateControl[layer]   = &m_acLayerCfg[layer].m_RCEnableRateControl;
-    cfg_RCTargetBitRate[layer]       = &m_acLayerCfg[layer].m_RCTargetBitrate;
-    cfg_RCKeepHierarchicalBit[layer] = &m_acLayerCfg[layer].m_RCKeepHierarchicalBit;
-    cfg_RCLCULevelRC[layer]          = &m_acLayerCfg[layer].m_RCLCULevelRC;
-    cfg_RCUseLCUSeparateModel[layer] = &m_acLayerCfg[layer].m_RCUseLCUSeparateModel;
-    cfg_RCInitialQP[layer]           = &m_acLayerCfg[layer].m_RCInitialQP;
-    cfg_RCForceIntraQP[layer]        = &m_acLayerCfg[layer].m_RCForceIntraQP;
-#endif
-
-    cfg_InputBitDepth   [CHANNEL_TYPE_LUMA][layer] = &m_acLayerCfg[layer].m_inputBitDepth[CHANNEL_TYPE_LUMA];
-    cfg_InternalBitDepth[CHANNEL_TYPE_LUMA][layer] = &m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_LUMA];
-    cfg_OutputBitDepth  [CHANNEL_TYPE_LUMA][layer] = &m_acLayerCfg[layer].m_outputBitDepth[CHANNEL_TYPE_LUMA];
-    cfg_InternalBitDepth[CHANNEL_TYPE_CHROMA][layer] = &m_acLayerCfg[layer].m_internalBitDepth[CHANNEL_TYPE_CHROMA];
-    cfg_InputBitDepth   [CHANNEL_TYPE_CHROMA][layer] = &m_acLayerCfg[layer].m_inputBitDepth[CHANNEL_TYPE_CHROMA];
-    cfg_OutputBitDepth  [CHANNEL_TYPE_CHROMA][layer] = &m_acLayerCfg[layer].m_outputBitDepth[CHANNEL_TYPE_CHROMA];
-
-    cfg_maxTidIlRefPicsPlus1[layer] = &m_acLayerCfg[layer].m_maxTidIlRefPicsPlus1;
+    cfg_RCEnableRateControl[layer]   = &m_apcLayerCfg[layer]->m_RCEnableRateControl;
+    cfg_RCTargetBitRate[layer]       = &m_apcLayerCfg[layer]->m_RCTargetBitrate;
+    cfg_RCKeepHierarchicalBit[layer] = &m_apcLayerCfg[layer]->m_RCKeepHierarchicalBit;
+    cfg_RCLCULevelRC[layer]          = &m_apcLayerCfg[layer]->m_RCLCULevelRC;
+    cfg_RCUseLCUSeparateModel[layer] = &m_apcLayerCfg[layer]->m_RCUseLCUSeparateModel;
+    cfg_RCInitialQP[layer]           = &m_apcLayerCfg[layer]->m_RCInitialQP;
+    cfg_RCForceIntraQP[layer]        = &m_apcLayerCfg[layer]->m_RCForceIntraQP;
+#endif
+
+    cfg_InputBitDepth   [CHANNEL_TYPE_LUMA][layer] = &m_apcLayerCfg[layer]->m_inputBitDepth[CHANNEL_TYPE_LUMA];
+    cfg_InternalBitDepth[CHANNEL_TYPE_LUMA][layer] = &m_apcLayerCfg[layer]->m_internalBitDepth[CHANNEL_TYPE_LUMA];
+    cfg_OutputBitDepth  [CHANNEL_TYPE_LUMA][layer] = &m_apcLayerCfg[layer]->m_outputBitDepth[CHANNEL_TYPE_LUMA];
+    cfg_InternalBitDepth[CHANNEL_TYPE_CHROMA][layer] = &m_apcLayerCfg[layer]->m_internalBitDepth[CHANNEL_TYPE_CHROMA];
+    cfg_InputBitDepth   [CHANNEL_TYPE_CHROMA][layer] = &m_apcLayerCfg[layer]->m_inputBitDepth[CHANNEL_TYPE_CHROMA];
+    cfg_OutputBitDepth  [CHANNEL_TYPE_CHROMA][layer] = &m_apcLayerCfg[layer]->m_outputBitDepth[CHANNEL_TYPE_CHROMA];
+
+    cfg_maxTidIlRefPicsPlus1[layer] = &m_apcLayerCfg[layer]->m_maxTidIlRefPicsPlus1;
 #if AUXILIARY_PICTURES
-    cfg_auxId[layer]                = &m_acLayerCfg[layer].m_auxId; 
-#endif
-    cfg_layerSwitchOffBegin[layer]  = &m_acLayerCfg[layer].m_layerSwitchOffBegin;
-    cfg_layerSwitchOffEnd[layer]    = &m_acLayerCfg[layer].m_layerSwitchOffEnd;
-    cfg_layerPTLIdx[layer]          = &m_acLayerCfg[layer].m_layerPTLIdx; 
+    cfg_auxId[layer]                = &m_apcLayerCfg[layer]->m_auxId; 
+#endif
+    cfg_layerSwitchOffBegin[layer]  = &m_apcLayerCfg[layer]->m_layerSwitchOffBegin;
+    cfg_layerSwitchOffEnd[layer]    = &m_apcLayerCfg[layer]->m_layerSwitchOffEnd;
+    cfg_layerPTLIdx[layer]          = &m_apcLayerCfg[layer]->m_layerPTLIdx; 
   }
 
